package game;

import sk.thenet.plustd.FM;
import sk.thenet.gamestd.bmp.BitmapData;

class APlayer extends Actor {
	public var animph:Int = 0;
	public var lastdir:Bool = true;
	public var vr:Bool = false;
	public var small:Bool = false;
	public var medium:Bool = false;
	public var runaway:Int = 0;
	
	public function new(nscreen:Screen){
		super("Player", nscreen);
		isPlayer = true;
	}
	
	override public function render(gs:GSGame, bd:BitmapData, sx:Int, sy:Int):Void {
		if (runaway > 0){
			bd.copyPixels(Assets.aPlayer,
				screen.walkmap_x - sx - 32 - (runaway << 1) + FM.floor(x * screen.walkmap_xx + y * screen.walkmap_xy),
				screen.walkmap_y - sy - 56 + (runaway) + FM.floor(x * screen.walkmap_yx + y * screen.walkmap_yy),
				232, runaway * 56 - 56, 48, 56);
			return;
		}
		x = gs.player_x + gs.player_pfapath[0] * gs.player_walkphase;
		y = gs.player_y + gs.player_pfapath[1] * gs.player_walkphase;
		var still:Bool = (gs.player_pfapath.length == 0);
		var scrxc:Int = FM.floor(gs.player_x * screen.walkmap_xx + gs.player_y * screen.walkmap_xy);
		var scrxn:Int = FM.floor(x * screen.walkmap_xx + y * screen.walkmap_xy);
		lastdir = (still
			? lastdir
			: (scrxn > scrxc ? true : (scrxn < scrxc ? false : lastdir))
		);
		
		var tx:Int = screen.walkmap_x - sx + FM.floor(x * screen.walkmap_xx + y * screen.walkmap_xy);
		var ty:Int = screen.walkmap_y - sy + FM.floor(x * screen.walkmap_yx + y * screen.walkmap_yy);
		if (small){
			tx -= (still ? 10 : 12);
			ty -= 52;
			var stx:Int = (still ? 0 : FM.floor(animph / 10) * 24 + 20);
			var sty:Int = (still || lastdir ? 0 : 52);
			bd.copyPixels(Assets.aPlayerSmall, tx, ty, stx, sty, still ? 20 : 24, 52);
			if (vr) bd.copyPixels(Assets.aPlayerSmall, tx, ty, stx, sty + 104, 20, 20);
		} else if (medium){
			tx -= (still ? 15 : 18);
			ty -= 78;
			var stx:Int = (still ? 0 : FM.floor(animph / 10) * 36 + 30);
			var sty:Int = (still || lastdir ? 0 : 78);
			bd.copyPixels(Assets.aPlayerMedium, tx, ty, stx, sty, still ? 30 : 36, 78);
			if (vr) bd.copyPixels(Assets.aPlayerMedium, tx, ty, stx, sty + 156, 30, 30);
		} else {
			tx -= (still ? 20 : 24);
			ty -= 104;
			var stx:Int = (still ? 0 : FM.floor(animph / 10) * 48 + 40);
			var sty:Int = (still || lastdir ? 0 : 104);
			bd.copyPixels(Assets.aPlayer, tx, ty, stx, sty, still ? 40 : 48, 104);
			if (vr) bd.copyPixels(Assets.aPlayer, tx, ty, stx, sty + 208, 40, 40);
		}
		
		if (still){
			animph = 0;
		} else {
			animph++;
			if (animph == 10 || animph == 30)
				if (gs.player_screen == 0)
					Noises.footstepJungle();
				else
					Noises.footstepFacility();
			animph %= 40;
		}
	}
}