package game;

import sk.thenet.plustd.audio.music.*;

class Noises {
	static var mngFootstepFacility:MusicManager;
	
	public static function init():Void {
		mngFootstepFacility = new MusicManager([new MMIWave(MMIWave.WT_SINE)], [
			[new MMEEcho(2000, 0.2)]
		]);
		mngFootstepFacility.instruments[0].volume = .09;
		mngFootstepFacility.addSection("noise", 0, [
			MMPatternBasic.fromNotes("C-1 STP", 200)
		], []);
	}
	
	public static function shortClick():MusicManager {
		var mng = new MusicManager([new MMINoise()]);
		mng.instruments[0].volume = .3;
		mng.addSection("noise", 3000, [
			MMPatternBasic.fromNotes("TRG", 1)
		], []);
		mng.playProgression(["noise"], false);
		return mng;
	}
	
	public static function shootDown():MusicManager {
		var mng = new MusicManager([new MMIWave(MMIWave.WT_SINE)]);
		mng.instruments[0].volume = .5;
		mng.addSection("noise", 0, [
			MMPatternBasic.fromNotes("A-7;slj-100,.95 STP", 200)
		], []);
		mng.playProgression(["noise"], false);
		return mng;
	}
	
	public static function footstepJungle():MusicManager {
		var mng = new MusicManager([new MMINoise()]);
		mng.instruments[0].volume = .09;
		mng.addSection("noise", 0, [
			MMPatternBasic.fromNotes("TRG;VOL1 ---;vol1", 1060)
		], []);
		mng.playProgression(["noise"], false);
		return mng;
	}
	
	public static function footstepFacility():MusicManager {
		mngFootstepFacility.playProgression(["noise"], false);
		return mngFootstepFacility;
	}
	
	public static function jungledoorOpen():MusicManager {
		var mng = new MusicManager([
			new MMINoise(),
			new MMIWave(MMIWave.WT_SQUARE),
			new MMIWave(MMIWave.WT_SQUARE)
		]);
		mng.instruments[0].volume = .3;
		mng.instruments[1].volume = .1;
		mng.instruments[1].pan = .4;
		cast(mng.instruments[1], MMIWave).duty = .4;
		mng.instruments[2].volume = .1;
		mng.instruments[2].volume = .6;
		cast(mng.instruments[2], MMIWave).duty = .45;
		mng.addSection("noise", 0, [
			MMPatternBasic.fromNotes("TRG;VOL1 ---;vol1", 100),
			MMPatternBasic.fromNotes("D#1;VOL.3 ---;vol1", 100),
			MMPatternBasic.fromNotes("E-1;VOL.3 ---;vol1", 100)
		], []);
		mng.playProgression(["noise"], false);
		return mng;
	}
	
	public static function loopGarage():MusicManager {
		var btempo:Float = 240;
		var mng = new MusicManager([
			new MMIWave(MMIWave.WT_TRIANGLE),
			new MMIWave(MMIWave.WT_SQUARE),
			new MMIWave(MMIWave.WT_SINE),
			new MMINoise()
		], []);
		mng.instruments[0].volume = .13;
		mng.instruments[1].volume = .09;
		cast(mng.instruments[1], MMIWave).duty = .61;
		mng.instruments[2].volume = .14;
		cast(mng.instruments[2], MMIWave).duty = .71;
		mng.instruments[3].volume = .05;
		mng.addSection("intro", 0, [
			MMPatternBasic.fromNotes("A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3", btempo),
			MMPatternBasic.fromNotes("--- --- A-5;VOL14 --- --- --- --- --- --- --- --- --- --- --- --- ---", btempo),
			MMPatternBasic.fromNotes("STP", btempo),
			MMPatternBasic.fromNotes("STP", btempo)
		], []);
		mng.addSection("main_a", 0, [
			MMPatternBasic.fromNotes("A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3 C-3 C-4 C-3 C-4 A-2 A-3 A-2 A-3", btempo),
			MMPatternBasic.fromNotes("A-4 C-5 E-5 A-4 C-5 E-5 A-4 C-5 E-5 A-4 C-5 E-5 A-4 C-5 E-5 A-4 C-5 E-5 A-4 C-5"
				+ "A-4 D-5 F-5 A-4 D-5 F-5 D-5 ---"
				+ "A-4 C-5 E-5 A-4 C-5 E-5 A-4 C-5", btempo * 2),
			MMPatternBasic.fromNotes("STP", btempo),
			MMPatternBasic.fromNotes("TRG STP --- --- --- --- --- --- TRG STP --- --- --- --- --- --- TRG STP --- --- --- --- --- --- TRG STP --- --- TRG STP --- ---", btempo * 4)
		], []);
		mng.addSection("main_b", 0, [
			MMPatternBasic.fromNotes("A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3 G#3 G#4 G#3 G#4 G#3 G#4 G#3 G#4", btempo),
			MMPatternBasic.fromNotes("A-4 H-4 C-5 D-5 E-5 A-4 STP A-4 STP", btempo * 2),
			MMPatternBasic.fromNotes("STP", btempo),
			MMPatternBasic.fromNotes("TRG STP --- --- --- --- --- --- TRG STP --- --- --- --- --- --- TRG STP --- --- --- --- --- --- TRG STP --- --- TRG STP --- ---", btempo * 4)
		], []);
		mng.addSection("main_c", 0, [
			MMPatternBasic.fromNotes("A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3 C-3 C-4 C-3 C-4 D-3 D-4 D-3 D-4", btempo),
			MMPatternBasic.fromNotes("A-4 E-4 D-4 C-4;vol4 --- --- --- STP --- --- --- --- --- --- A-4;VOL1 ---;vol1", btempo),
			MMPatternBasic.fromNotes("A-4;sli-1,1 --- D-5 E-5 D-5 --- A-4;sli-1,1 --- G#4 D-5;sli-30,1 E-5 D-5 G#4;slj4,1 --- ---", btempo),
			MMPatternBasic.fromNotes("TRG STP --- --- --- --- --- --- --- --- --- --- --- --- --- --- TRG;VOL4 --- --- --- STP --- --- --- TRG STP --- --- TRG STP --- ---", btempo * 4)
		], []);
		mng.addSection("main_d", 0, [
			MMPatternBasic.fromNotes("A-2 A-3 A-2 A-3 A-2 A-3 A-2 A-3 C-3 C-4 C-3 C-4 D-3 D-4 D-3 D-4", btempo),
			MMPatternBasic.fromNotes("A-4 E-4 D-4 A-4;vol4 --- --- --- STP --- --- --- --- --- --- A-4;VOL1 ---;vol1", btempo),
			MMPatternBasic.fromNotes("A-4;sli1,1 --- D-5 E-5;sli-30,1 --- D-5 A-4 --- G#4 D-5;sli-10,1 E-5;vol1 D-5 G#4;slj4,1 --- ---", btempo),
			MMPatternBasic.fromNotes("TRG STP --- --- --- --- --- --- TRG STP --- --- --- --- --- --- TRG STP --- --- --- --- --- --- TRG STP --- --- TRG STP --- ---", btempo * 4)
		], []);
		mng.playProgression(["intro", "main_a", "main_a", "main_b", "main_c", "main_c", "main_d", "main_a"]);
		return mng;
	}
	
	public static function loopJungle():MusicManager {
		var btempo:Float = 120;
		var mng = new MusicManager([
			new MMIWave(MMIWave.WT_SINE),
			new MMIWave(MMIWave.WT_SINE),
			new MMINoise(),
			new MMIWave(MMIWave.WT_SINE),
			new MMINoise()
		]);
		mng.instruments[0].volume = .13;
		mng.instruments[1].volume = .3;
		mng.instruments[2].volume = .1;
		mng.instruments[3].volume = .2;
		mng.instruments[4].volume = .04;
		mng.addSection("noise", -1, [
			MMPatternBasic.fromNotes("--- --- C-3;VOL3 --- --- G-3;slj5,1 --- D#3;slj3,1 --- ---;vol1 STP"
			+ " --- --- --- --- --- --- --- --- --- ---", btempo),
			MMPatternBasic.fromNotes("--- --- C-2;arp4,6,0,.05 STP --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- C-5;slj3.5,.5 D-5;sli4.5,.5 STP --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---", btempo * 3),
			MMPatternBasic.fromNotes("--- --- TRG;VOL.8 ---;vol1 STP"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- TRG;VOL.8 ---;vol10"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " STP --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ "--- --- TRG;VOL.8 ---;vol1 STP"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- TRG;VOL3.7 --- --- --- STP --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- --- --- --- --- ---", btempo * 9),
			MMPatternBasic.fromNotes("C-3 --- --- F#3 --- C-3 --- G-2 F#2", btempo / 3),
			MMPatternBasic.fromNotes("TRG;VOL.5 ---;VOL1 STP TRG;VOL.5 ---;VOL1 STP TRG;VOL.5 ---;VOL1 STP"
			+ " --- --- --- --- --- --- --- --- ---"
			+ " --- --- --- --- --- TRG;vol.2 --- --- ---", btempo * 3)
		], [
		]);
		mng.playProgression(["noise"]);
		return mng;
	}
	
	public static function musicBootup(complete:Bool):MusicManager {
		var btempo:Float = 30;
		var mng = new MusicManager([
			new MMIWave(MMIWave.WT_TRIANGLE),
			new MMIWave(MMIWave.WT_TECHBRAS),
			new MMIWave(MMIWave.WT_TECHBRAS)
		], [
			[new MMEADSR(MMPattern.countSamples(.1, btempo), MMPattern.countSamples(.2, btempo),
				.8, MMPattern.countSamples(.3, btempo))],
			[new MMEADSR(MMPattern.countSamples(3.2, btempo), MMPattern.countSamples(0, btempo),
				1, MMPattern.countSamples(4.3, btempo))],
			[new MMEADSR(MMPattern.countSamples(3.2, btempo), MMPattern.countSamples(0, btempo),
				1, MMPattern.countSamples(4.3, btempo))]
		]);
		mng.instruments[0].volume = .3;
		mng.instruments[0].effects[0].persist_trigger = true;
		mng.instruments[1].volume = .28;
		mng.instruments[1].pan = .3;
		mng.instruments[1].effects[0].persist_trigger = true;
		mng.instruments[2].volume = .28;
		mng.instruments[2].pan = .7;
		mng.instruments[2].effects[0].persist_trigger = true;
		mng.addSection("noise", 0, [
			MMPatternBasic.fromNotes("C-2;arp2,10,0,.1 D#2;arp2,10,0,.1 F#2;arp2,10,0,.1 A-2;arp2,10,0,.1", btempo),
			MMPatternBasic.fromNotes("--- D#1 STP A-1", btempo),
			MMPatternBasic.fromNotes("--- --- F#1 STP", btempo)
		], [
		]);
		mng.playProgression(["noise"], false);
		return mng;
	}
}