package game;

import sk.thenet.plustd.FM;
import sk.thenet.gamestd.bmp.BitmapData;

class VR {
	public static function renderObjective(obj:String):BitmapData {
		var ret = new BitmapData(320, 190, 0);
		var vec = ret.getFullVector();
		var r:Int = 0;
		var g:Int = 0;
		var b:Int = 0;
		for (i in 0...vec.length){
			vec[i] = 0xFF000000 | ((r & 0xFF) << 16) | ((g & 0xFF) << 8) | (b & 0xFF);
			r++;
			g++;
			b++;
			r %= 1031;
			g %= 617;
			b %= 891;
		}
		ret.setFullVector(vec);
		ret.fillRect(110, 20, 100, 80, 0x8833DDFF);
		Assets.fMachine.render(ret, "OBJECTIVE:\n\n" + obj + "\n\n" + obj, 160 - FM.floor(obj.length * 3.5), 35, 100);
		return ret;
	}
	
	public static function renderEnding(obj:String):BitmapData {
		var ret = new BitmapData(320, 190, 0);
		var vec = ret.getFullVector();
		var r:Int = 0;
		var g:Int = 0;
		var b:Int = 0;
		for (i in 0...vec.length){
			vec[i] = 0xFF000000 | ((r & 0xFF) << 16) | ((g & 0xFF) << 8) | (b & 0xFF);
			r++;
			g++;
			b++;
			r %= 1031;
			g %= 617;
			b %= 891;
		}
		ret.setFullVector(vec);
		ret.fillRect(10, 20, 300, 160, 0x8833DDFF);
		var w:Int = 0;
		var ts:Array<String> = obj.split("\n");
		for (t in ts) if (t.length > w) w = t.length;
		Assets.fMachine.render(ret, "OBJECTIVE:\n\n" + obj + "\n\n" + obj, 160 - FM.floor(w * 3.5), 35, 100);
		return ret;
	}
	
	public static var pts:Array<{x:Float, y:Float, r:Float}>;
	
	public static function repoint(dmg:Int = 12):Void {
		pts = [];
		for (i in 0...(dmg + FM.floor(Math.random() * 3))){
			pts[i] = {
				x: Math.random() * 340 - 20,
				y: Math.random() * 210 - 20,
				r: (Math.random() * dmg * .66) - dmg * .33
			};
		}
	}
	
	public static function virtualise(vbd:BitmapData, bd:BitmapData, ph:Int):Void {
		for (y in (ph * 10)...(ph * 10 + 10)) for (x in 0...320){
			var tx:Float = x;
			var ty:Float = y;
			for (p in pts){
				var dx:Float = tx - p.x;
				var dy:Float = ty - p.y;
				var dist:Float = Math.sqrt(dx * dx + dy * dy);
				tx += 0.05 * (p.r / dist) * 2 * p.x;
				ty += 0.05 * (p.r / dist) * 2 * p.y;
			}
			vbd.set(x, y, bd.get(FM.floor(tx), FM.floor(ty)));
		}
	}
}