package sk.thenet.gamestd;

import haxe.ds.StringMap;
import sk.thenet.gamestd.bmp.BitmapData;
import sk.thenet.gamestd.bmp.BitmapRenderer;
import sk.thenet.gamestd.input.*;

class Stater {
	public var sca:Int = 1; // bmp scale
	public var bd:BitmapData;
	public var bmprnd:BitmapRenderer;
	public var kb:Keyboard;
	public var ms:Mouse;
	public var states:Array<StaterState>;
	public var cst:String = "default"; // current state id
	public var cstr:StaterState; // current state
	public var data:StringMap<Dynamic>;
	
	public function new(){
		states = new Array<StaterState>();
		states.push(new StaterState("default"));
		cstr = states[0];
		data = new StringMap<Dynamic>();
	}
	
	public function initBitmap(w:Int, h:Int, s:Int):Void {
		sca = s;
		bd = new BitmapData(w, h, 0xFF000000);
		bmprnd = new BitmapRenderer(bd, s, this);
	}
	
	public function initKeyboard():Void {
		kb = new Keyboard(this);
	}
	
	public function initMouse():Void {
		ms = new Mouse(this);
	}
	
	public function frame():Void {
		cstr.fFrame(this);
	}
	
	public function switchTo(st:String, id:StringMap<Dynamic> = null):Void {
		cstr.fFrom(this);
		cst = st;
		for (st in states){
			if (st.name == cst){
				cstr = st;
				cstr.fTo(this, id);
				return;
			}
		}
	}
	
	public function addState(ss:StaterState):Void {
		states.push(ss);
	}
}