package sk.thenet.plustd;

class FM {
	public static inline function absI(x:Int):Int return (x ^ (x >> 31)) - (x >> 31);
	public static inline function absF(x:Float):Float return (x < 0 ? -x : x);
	public static inline function isNegI(x:Int):Bool return (x >>> 31) != 0;
	#if flash
	public static inline function floor(a:Float):Int return untyped __global__["int"](a);
	public static inline function round(a:Float):Int return untyped __global__["int"](a + .5);
	public static inline function ceil(a:Float):Int return untyped __global__["int"](a + 1);
	#else
	public static inline function floor(a:Float):Int return Math.floor(a);
	public static inline function round(a:Float):Int return Math.floor(a + .5);
	public static inline function ceil(a:Float):Int return Math.floor(a + 1);
	#end
	public static inline function clampF(x:Float, min:Float, max:Float):Float return (x < min ? min : (x > max ? max : x));
	public static inline function clampI(x:Int, min:Int, max:Int):Int return (x < min ? min : (x > max ? max : x));
	public static inline function minF(x:Float, y:Float):Float return (x < y ? x : y);
	public static inline function minI(x:Int, y:Int):Int return (x < y ? x : y);
	public static inline function maxF(x:Float, y:Float):Float return (x > y ? x : y);
	public static inline function maxI(x:Int, y:Int):Int return (x > y ? x : y);
}