package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;

class MMEArpeggio extends MMEffect {
	public var pattern:Int;
	public var steps:Int;
	public var dir:Int;
	public var cdir:Bool;
	public var speed:Float;
	public var sph:Int;
	public var fph_trig:Bool = false;
	
	public function new(npattern:Int, nsteps:Int, ndir:Int, nspeed:Float):Void {
		super();
		tapl = MMEffect.ETA_NOTES;
		pattern = npattern;
		steps = nsteps;
		dir = ndir;
		speed = nspeed;
		reset();
	}
	
	override public function reset():Void {
		super.reset();
		gate = 0;
		done = false;
		cdir = (dir % 2 == 0 ? true : false);
		ph = 0;
		sph = 0;
		fph_trig = false;
	}
	
	override public function trigger(trig:Int, ttype:Int):Void {
		if (triggered) return;
		triggered = true;
		if (trig > 0 && gate == 0){
			cdir = (dir % 2 == 0 ? true : false);
			ph = 0;
			sph = 0;
			fph_trig = false;
			gate = 1;
		} else if (trig != 0){
			if (!persist_trigger){
				done = true;
				gate = 0;
			} else {
				gate = (trig < 0 ? 0 : 1);
			}
		}
	}
	
	override public function applyNotes(instr:MMInstrument, c:Int):Void {
		if (gate > 0){
			var off:Int = MusicManager.PATTERNS[pattern][sph < 0
				? ((MusicManager.PATTERNS[pattern].length - 1) + ((sph + 1) % MusicManager.PATTERNS[pattern].length))
				: (sph % MusicManager.PATTERNS[pattern].length)] + (sph < 0
				? FM.floor((sph - (MusicManager.PATTERNS[pattern].length - 1)) / MusicManager.PATTERNS[pattern].length)
				: FM.floor(sph / MusicManager.PATTERNS[pattern].length)) * 12;
			if (!fph_trig){
				instr.notes += off;
				instr.freq = MusicManager.indexToFreq(instr.notes);
				instr.trig = (instr.trig == 0 ? 2 : instr.trig);
				fph_trig = true;
			}
			ph += 1;
			if (ph >= speed){
				ph -= speed;
				fph_trig = false;
				if (dir < 2){
					sph += (dir == 0 ? 1 : -1);
					if (sph >= steps || sph <= -steps) sph = 0;
				} else {
					sph += (cdir ? 1 : -1);
					if (dir == 2 && sph >= steps) cdir = false;
					else if (dir == 2 && sph <= 0) cdir = true;
					if (dir == 3 && sph <= -steps) cdir = true;
					else if (dir == 3 && sph >= 0) cdir = false;
				}
			}
		}
	}
}