package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;

class MMInstrument {
	public var volume:Float = 1;
	public var pan:Float = .5;
	
	public var gate:Int = 0;
	
	public var ph:Float = 0;
	public var lfreq:Float = 0;
	
	public var notes:Float;
	public var freq:Float;
	public var trig:Int;
	public var effects:Array<MMEffect>;
	
	public var effects_buf:Array<MMEffect>;
	public var effects_pos:Array<Int>;
	
	public function new(){
		effects = [];
		effects_buf = [];
		effects_pos = [];
		reset();
	}
	
	public inline function addEffect(eff:MMEffect):Void {
		effects.push(eff);
	}
	public inline function addPatternEffect(eff:MMEffect, pos:Int):Void {
		effects_buf.push(eff);
		effects_pos.push(pos);
	}
	public function reset():Void {
		ph = 0;
		lfreq = 0;
		notes = -1;
		freq = -1;
		trig = 0;
	}
	public function buffer():Float {return 0;}
}