package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;
import sk.thenet.plustd.FM;

class MMPatternAuto extends MMPattern {
	public var pattern:Int;
	public var basenote:Float;
	public var fph:Int;
	public var tph:Float;
	public var sph:Int;
	public var splay:Bool;
	public var len:Int = 0;
	public var fph_trig:Bool;
	
	public function new(npattern:Int, nbasenote:Float, ntempo:Float){
		super(ntempo);
		pattern = npattern;
		basenote = nbasenote;
		reset();
	}
	
	override public function reset():Void {
		super.reset();
		fph = 0;
		tph = 0;
		sph = 12;
		splay = true;
		len = 0;
		fph_trig = false;
	}
	
	override public inline function setFreq(instr:MMInstrument, effa:Array<MMEffect>, start:Int, end:Int):Void {
		for (c in start...end){
			var off:Int = MusicManager.PATTERNS[pattern][sph % MusicManager.PATTERNS[pattern].length]
				+ (FM.floor(sph / MusicManager.PATTERNS[pattern].length)) * 12;
			instr.notes[c] = basenote + off;
			instr.freq[c] = MusicManager.indexToFreq(basenote + off);
			if (!fph_trig){
				instr.trig[c] = splay ? 1 : -1;
				fph_trig = true;
			} else {
				instr.trig[c] = 0;
			}
			
			if (!eftrig && effects.length > 0 && effects_step[efph] == fph){
				var lg:Int = 0;
				while (lg++ < effects.length && effects_step[efph] == fph){
					effects[efph].reset();
					effa.push(effects[efph]);
					efph++;
					efph %= effects.length;
				}
				eftrig = true;
			}
			tph += 1;
			if (tph >= tempo){
				if (len > 0) len--;
				else {
					fph_trig = false;
					splay = (Math.random() < .96);
					sph += FM.floor((Math.random() * 4 - 2) * Math.random() * 4);
					len = FM.floor(Math.random() * Math.random() * 3);
					if (Math.random() > .9){
						var steps = FM.floor(Math.random() * 4) + 3;
						var arp = new MMEArpeggio(pattern, steps, 0, MMPattern.countSamples((len + 1) / steps, tempo_orig));
						//trace("new arp", steps, len * tempo);
						arp.ttl_act = true;
						arp.ttl = (len + 1) * tempo;
						arp.start = start;
						arp.end = end;
						effa.push(arp);
					}
				}
				if (sph < 0) sph += 24;
				else if (sph >= 24) sph -= 24;
				eftrig = false;
				tph -= tempo;
			}
		}
	}
}